commit a5d388407de4c01426558aa6908a98c79f34dd00
Author: freddy77 <freddy77>
Date:   Wed Oct 22 15:22:59 2008 +0000

    initial SQL_C_WCHAR support

diff --git a/ChangeLog b/ChangeLog
index 780ab38..4ca610c 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,7 @@
+Mon Oct 22 17:21:18 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/odbc/odbc_util.c src/odbc/unittests/data.c:
+	- initial SQL_C_WCHAR support
+
 Mon Oct 22 16:14:20 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/odbc/unittests/data.c: improve
 
@@ -731,4 +735,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2629 2008/10/22 14:15:24 freddy77 Exp $
+$Id: ChangeLog,v 1.2630 2008/10/22 15:22:59 freddy77 Exp $
diff --git a/src/odbc/odbc_util.c b/src/odbc/odbc_util.c
index 40fb59c..450f391 100644
--- a/src/odbc/odbc_util.c
+++ b/src/odbc/odbc_util.c
@@ -39,7 +39,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: odbc_util.c,v 1.105 2008/10/17 08:30:03 freddy77 Exp $");
+TDS_RCSID(var, "$Id: odbc_util.c,v 1.106 2008/10/22 15:22:59 freddy77 Exp $");
 
 /**
  * \ingroup odbc_api
@@ -371,6 +371,7 @@ odbc_server_to_sql_type(int col_type, int col_size)
 /**
  * Pass this an SQL_C_* type and get a SYB* type which most closely corresponds
  * to the SQL_C_* type.
+ * This function can return XSYBNVARCHAR even if server do not support it
  */
 int
 odbc_c_to_server_type(int c_type)
@@ -379,6 +380,10 @@ odbc_c_to_server_type(int c_type)
 		/* FIXME this should be dependent on size of data !!! */
 	case SQL_C_BINARY:
 		return SYBBINARY;
+#ifdef SQL_C_WCHAR
+	case SQL_C_WCHAR:
+		return XSYBNVARCHAR;
+#endif
 		/* TODO what happen if varchar is more than 255 characters long */
 	case SQL_C_CHAR:
 		return SYBVARCHAR;
@@ -434,9 +439,6 @@ odbc_c_to_server_type(int c_type)
 	case SQL_C_INTERVAL_HOUR_TO_MINUTE:
 	case SQL_C_INTERVAL_HOUR_TO_SECOND:
 	case SQL_C_INTERVAL_MINUTE_TO_SECOND:
-#ifdef SQL_C_WCHAR
-	case SQL_C_WCHAR:
-#endif
 		break;
 	}
 	return TDS_FAIL;
@@ -973,6 +975,7 @@ odbc_set_concise_sql_type(SQLSMALLINT concise_type, struct _drecord * drec, int
 	TYPE_NORMAL(SQL_C_BINARY) \
 \
 	TYPE_NORMAL(SQL_C_CHAR) \
+	TYPE_NORMAL(SQL_C_WCHAR) \
 \
 	TYPE_NORMAL(SQL_C_NUMERIC) \
 \
diff --git a/src/odbc/unittests/data.c b/src/odbc/unittests/data.c
index 53a01cf..5aaf532 100644
--- a/src/odbc/unittests/data.c
+++ b/src/odbc/unittests/data.c
@@ -13,7 +13,7 @@
  * Also we have to check normal char and wide char
  */
 
-static char software_version[] = "$Id: data.c,v 1.19 2008/10/22 14:15:24 freddy77 Exp $";
+static char software_version[] = "$Id: data.c,v 1.20 2008/10/22 15:22:59 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static int result = 0;
@@ -71,7 +71,7 @@ Test(const char *type, const char *value_to_convert, SQLSMALLINT out_c_type, con
 		assert(out_len >=0 && (out_len % sizeof(SQLWCHAR)) == 0);
 		sprintf(sbuf, "%u ", (unsigned int) (out_len / sizeof(SQLWCHAR)));
 		wp = (SQLWCHAR*) out_buf;
-		for (i = 0; i < out_len; ++i)
+		for (i = 0; i < out_len / sizeof(SQLWCHAR); ++i)
 			if ((unsigned int) wp[i] < 256)
 				sprintf(strchr(sbuf, 0), "%c", (char) wp[i]);
 			else
@@ -146,7 +146,8 @@ main(int argc, char *argv[])
 
 		Test("VARCHAR(20)", "test", SQL_C_WCHAR, "4 test");
 		/* nvarchar with extended characters */
-		Test("NVARCHAR(20)", "0x830068006900f200", SQL_C_WCHAR, "4 \\u0083hi\\u00f2");
+		Test("NVARCHAR(20)", "0x830068006900f200", SQL_C_WCHAR, "4 \x83hi\xf2");
+		Test("NVARCHAR(20)", "0xA406A5FB", SQL_C_WCHAR, "2 \\u06a4\\ufba5");
 	}
 
 	/* case (1) */

